
/* august.c hacked up to build under z80c. And cleaned up. 
   It now doesn't support compressed input. */
#include "z80c.h"

/* Ack pfft. The original was 40K. My Z80 box has 8K. Ho hum. */
#define MEMSIZE 20000

/* The memory image
   This is int because although the program uses only byte operands,
   the data size is int */
int m[MEMSIZE];

/* int */
main() {
  int *q,s,f,r,o,l,p,c; 
  /* removed int b, just used as constant 256 */
  char *d;

  q=m; /* Point q at the memory image base, it's used for writing */

  getchar(); getchar(); /* just a compressed-not compressed flag */
  c=getchar(); c=c+getchar()*256; /* size of the program */
  p=c; /* used to count reading in bytes */
  while (p--)
    *q++=getchar();

  /* s=stack pointer, p=program counter, m=memory image, r=scratch,
     o=current op
     The stack decrements to push values.
     Execution begins here */
  s=MEMSIZE;
  p=0;
  while (1) {
    o= m[p++] ; /* fetch the next opcode */
    /* 17 bitwise negate */
    if (o==  17  ){ m[s] = !  m[s]  ;}
    /* 18 unary negate */
    else if (o==  18  ){ m[s] = -  m[s]  ;}
    else if (o==  12  ){ r= m[s++] ;m[s] = m[s]   +  r ;}
    else if (o==  13  ){ r= m[s++] ;m[s] = m[s]   -  r ;}
    else if (o==  14  ){ r= m[s++] ;m[s] = m[s]   *  r ;}
    else if (o==  15  ){ r= m[s++] ;m[s] = m[s]   /  r ;}
    else if (o==  16  ){ r= m[s++] ;m[s] = m[s]   %  r ;}
    else if (o==  6  ){ r= m[s++] ;m[s] = m[s]   ==  r ;}
    else if (o==  7  ){ r= m[s++] ;m[s] = m[s]   !=  r ;}
    /* 8 (a r - a<r) */
    else if (o==  8  ){ r= m[s++] ;m[s] = m[s]   <  r ;}
    /* 1 (a r - (m[a]=r))  -  assignment op */
    else if (o== 1 ){ r= m[s++] ;m[m[s] ]=r;m[s] =r ;}
    /* 9 (a r -) m[a]=r    - assignment op without result */
    else if (o== 9 ){ r= m[s++] ;m[m[s] ]=r;s++ ;}
    /* 10 return, no idea how it works... */
    else if (o== 10 ) {
      r=m[s]; /* the value returned */
      s=f; /* f is the previous SP */
      p=m[s-1]; /* old pc: set the program counter */
      f=m[s-2]; /* next f down */
      l=m[s-3]; /* number of args to lose */
      s=s+l/2; /* drop l/2 items from the stack -- is l # params? */
      m[s] =r; /* shove the return on to the stack */
      if (l%2) /* if l is odd, void return?? */
	s++;
    }
    /* drop */
    else  if (o== 22 ){ s++ ;}
    /* quit (this is the escape char!) */
    else  if (o== 27 ){ return m[s]  ;}
    /* dup */
    else  if (o== 21 ) { 
      r= m[s] ;
      s--;
      m[s] = r;  /* Presumably m[s--]=m[s] is too ambiguous. */
    }
    /* peek */
    else  if (o== 23 ){ m[s] =m[m[s] ] ;}
    /* peek and increment (a++) */
    else  if (o== 19 ){ m[s] =m[m[s] ]++ ;}
    /* peek and decrement (a--) */
    else  if (o== 25 ){ m[s] =m[m[s] ]-- ;}
    /* These do a function call (I think!) */
    else {
      l=o%16; /* number of arguments */
      o=o/16;
      if (l==7) { /* RH bits are 0111 */
	l= m[p++] ; /* what's p? */
	l=l+ m[p++]*256;
      } else if (l>7) /* Bit 3 set (1xxx) */
	l=l+ m[p++]*8-1;
      if (o==  2  ) /* push f+l */
	{ s--;m[s] =  f+l    ;}
      else if (o==  4  )
	{ s--;m[s] =  f-l-4    ;}
      else if (o==  3  )
	{ s--;m[s] =  m[f+l]    ;}
      else if (o==  5  )
	{ s--;m[s] =  m[f-l-4]    ;}
      /* c got loaded with bytes 2-3 of the prog at the start... help! */
      else if (o==  6  )
	{ s--;m[s] =  c+l    ;} 
      else if (o==  7  )
	{ s--;m[s] =  m[c+l]    ;}
      /* don't know what the point in this is, both 12 and 8 behave the same */
      else if (o==  12  )
	{ s--;m[s] =  l    ;}
      else if (o==  8  )
	{ s--;m[s] =  l    ;}
      else if (o== 9 )
	{ s--;m[s] = p  ;p=p+l ;}
      /* call */
      else  if (o== 11 ) { 
	r= m[s-(-l)/2]; /* I don't know how this is interpreted, but
			 r is either 0>=r>=3 for an internal func call,
			 or is r>3 for a call in the VM's memory */
	if (r<3) { /* call a builtin function */
	  if (r) /* r=1? */
	    r=putchar(m[s]);
	  else /* r=0 */
	    r=getchar() ;
	  s=s+l/2;
	  m[s]=r;
	  if (l%2) /* damn obfuscation! this means if it was putchar, drop? */
	    s++;
	} else { /* call a user function */
	  m[s-1]=p; /* store the pc to return to */
	  m[s-2]=f; /* store the last sp, current f (used uninitialised first time) */
	  m[s-3]=l; /* store number of args */
	  f=s; /* this is the only way f can get implicitly set,
		f being the "last sp" */
	  s=s-19; /* Aren't magic values annoying? */
	  p=r; /* Jump to r */
	};
      }
      /* I think these rely on l==7 before so that l gets loaded
	 with a value from the program. */
      else  if (o== 13 ){ p=l;} /* unconditional jump */
      else  if (o== 15 ){ if (m[s++]) p=l;} /* conditional jumps */
      else  if (o== 14 ){ if (!m[s++]) p=l;}
      else  ;
    }
  }
}
